package com.michaelflisar.materialpreferences.preferencescreen.preferences

import android.view.LayoutInflater
import android.view.ViewGroup
import com.michaelflisar.materialpreferences.preferencescreen.R
import com.michaelflisar.materialpreferences.preferencescreen.ViewHolderFactory
import com.michaelflisar.materialpreferences.preferencescreen.classes.Badge
import com.michaelflisar.materialpreferences.preferencescreen.classes.Icon
import com.michaelflisar.materialpreferences.preferencescreen.dependencies.Dependency
import com.michaelflisar.materialpreferences.preferencescreen.enums.NoIconVisibility
import com.michaelflisar.materialpreferences.preferencescreen.interfaces.PreferenceItem
import com.michaelflisar.materialpreferences.preferencescreen.recyclerview.PreferenceAdapter
import com.michaelflisar.materialpreferences.preferencescreen.recyclerview.viewholders.CategoryViewHolder
import com.michaelflisar.text.Text

class CategoryHeaderPreference : PreferenceItem.Category {

    override var title: Text = Text.Empty

    override var enabledDependsOn: Dependency<*>? = null
    override var visibilityDependsOn: Dependency<*>? = null

    companion object : ViewHolderFactory.ViewHolderCreator {
        val TYPE = R.id.pref_category
        override fun createViewHolder(adapter: PreferenceAdapter, layoutInflater: LayoutInflater, parent: ViewGroup) =
                CategoryViewHolder(layoutInflater, parent, adapter)
    }

    override val type = TYPE
}